def get_style() -> str:
    """Get the style for qgraf to produce feynml."""
    return r"""
<prologue>
<<!--
 file generated by <program>

<command_loop><command_line_loop> <command_data><end><end>

 You must add x= and y= with suitable vertex positions.
 Some lines may need manual bending to render properly.
-->>
<<feynml>>
<diagram>
  <back>
 <<diagram 
          id="Diagram<diagram_index>"
          incoming="<legs_in>"
          outgoing="<legs_out>"
          sign="<sign>"
          symmmetry_factor="<symmetry_factor>"
 >>

<vertex_loop> 
  <<vertex id="Vert<vertex_index>">>
  <</vertex>>
<end>

<in_loop>
  <<leg id="In<in_index>">>  
        <<name>><field><</name>>
        <<sense>>incoming<</sense>>
        <<target>>Vert<vertex_index><</target>>
  <</leg>>
<end>

<out_loop> 
  <<leg id="Out<out_index>">>  
        <<name>><field><</name>>
        <<sense>>outgoing<</sense>>
        <<target>>Vert<vertex_index><</target>>
  <</leg>>
<end>

<propagator_loop> 
  <<propagator id="Prop<propagator_index>">>  
               <<name>><field><</name>>
               <<source>>Vert<dual-vertex_index><</source>>
               <<target>>Vert<vertex_index><</target>>
  <</propagator>>
<end>

 <</diagram>>
<epilogue>
<</feynml>>

<<!-- end -->>
<exit>
"""


def get_example_model() -> str:
    """Get an example model for qgraf."""
    return r"""
* QGRAF-3 Model Definition

* PROPOGATOR DEFINITIONS 
[g,g,+]
[gamma,gamma,+]
[u,u_bar,+]

* VERTEX DEFINITIONS 
[u,u_bar,g]
[u,u_bar,gamma]
[g,g,g,g]
[g,g,g]
* YOU HAVE REACHED THE END MY FRIEND
"""
